package com.weaver.seconddev.njwebservice.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.nacos.api.NacosFactory;
import com.alibaba.nacos.api.config.ConfigService;
import com.alibaba.nacos.api.exception.NacosException;
import com.weaver.common.hrm.util.Util;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.seconddev.njwebservice.entity.DataOptions;
import com.weaver.seconddev.njwebservice.entity.FormDataDuty;
import com.weaver.verupgrade.conn.CONN_TYPE;
import com.weaver.verupgrade.conn.RecordSet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.*;

/**
 * @Author liang.cheng
 * @Date 2025/1/7 11:20 AM
 * @Description: 二开工具类
 * @Version 1.0
 */
public class SecondUtil {
    private final static Logger log = LoggerFactory.getLogger(SecondUtil.class);




    public static String getNacosContent(String dataId,String group,String key) {
        String configSingle = "";
        // 定义 Nacos 服务器地址和配置信息
        String serverAddr = "10.6.23.235:20000";

        // 初始化 Nacos 配置服务
        Properties properties = new Properties();
        properties.put("serverAddr", serverAddr);

        try {
            ConfigService configService = NacosFactory.createConfigService(properties);
            String content = configService.getConfig(dataId, group, 5000);
            log.error("Config content: " + content);

            // 解析 Properties 文件
            Properties prop = new Properties();
            prop.load(new java.io.ByteArrayInputStream(content.getBytes()));
            configSingle = prop.getProperty(key);
        } catch (NacosException | java.io.IOException e) {
            log.error("Failed to get config: " + e.getMessage());
        }
        return configSingle;
    }

    public static String getWorkflowConfig(String loginName) {
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.ebuilder.getType();
        String pwd = "";
        String sql = "select pro from uf_submitconfig where zdmc = '"+loginName+"'";
        rs.executeSql(sql,poolname);
        if (rs.next()){
            pwd = Util.null2String(rs.getString("pro"));
        }
        return pwd;
    }

    public static String validationParam(String loginName,String password,String workflowId,String creator) {
        //1.权限判断 （日志返回获取nacos文件权限不足 todo）
//        String pwd = getNacosContent("weaver-secondev-wsaccount.properties", "DEFAULT_GROUP", loginName);
//        log.error("配置文件获取值："+pwd);
//        if(pwd == null || !pwd.equals(password)){
//            return "权限不足...";
//        } 采用eb表单

        String pwd = getWorkflowConfig(loginName);
        log.info("validationParam pwd = " + pwd);
        if("".equals(pwd) || !pwd.equals(password)){
            return "该流程id不在可创建流程列表";
        }

        //2.todo e10获取ip地址 log4fj记录
        log.error("调用主机ip地址日志记录");

        //3.流程名 流程ID
        if ("".equals(workflowId)) {
            return "流程ID不能为空...";
        }

        //4.todo 流程id不存在时默认流程 e10不知道怎么查

        //5.创建人
        if("".equals(creator)) {
            return "创建人不能为空...";
        }

        return "";
    }


    /**
     * 获取明细表Id
     * @param workflowId
     * @return
     */
    public static List<Long> getDetailFormId(String workflowId) {
        log.error("getDetailFormId start : " + workflowId);
        List<Long> formIdList = new ArrayList();
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        String poolname = CONN_TYPE.workflow.getType();
        String sql = "select form_id from form_table where form_id in (select id from sub_form where form_id in (select relatekey from e10_core_business.dbo.wfp_relateform  where workflowid = '"+workflowId+"'))";
        rs.executeSql(sql,poolname);
        while (rs.next()){
            formIdList.add(Util.getLongValue(rs.getString("form_id")));
        }

        log.error("formIdList : " + formIdList);
        return formIdList;
    }


    /**
     * 表单字段构建
     * @return
     */
    public static JSONObject getFromDataByDataDetails(List<FormDataDuty> formDataDutyList) {
        JSONObject formData = new JSONObject();
        formData.put("module","workflow");

        JSONArray dataDetails = new JSONArray();
        formData.put("dataDetails", dataDetails);

//        JSONObject inputDataKey = new JSONObject();
//        inputDataKey.put("dataKey", "sqdh");
//        inputDataKey.put("content", "12345");
//        dataDetails.add(inputDataKey);
//
//        //申请人
//        JSONObject sqr = new JSONObject();
//        dataDetails.add(sqr);
//        JSONArray dataOptions = new JSONArray();
//        sqr.put("dataKey","sqr");
//        sqr.put("dataOptions",dataOptions);
//
//        JSONObject option = new JSONObject();
//        option.put("optionId",100001700000063120L);
//        dataOptions.add(option);
//
//
//        //申请部门
//
//        JSONObject sqbm = new JSONObject();
//        dataDetails.add(sqbm);
//        JSONArray dataOptions_sqbm = new JSONArray();
//        sqbm.put("dataKey","sqbm");
//        sqbm.put("dataOptions",dataOptions_sqbm);
//
//        JSONObject option_sqbm = new JSONObject();
//        option_sqbm.put("optionId",100001590000004676L);
//        dataOptions_sqbm.add(option_sqbm);
//
//        JSONObject aa1 = new JSONObject();
//        dataDetails.add(aa1);
//        aa1.put("dataKey","wlbh");
//        aa1.put("dataIndex",1L);
//        aa1.put("content","1");
//        aa1.put("subFormId","100003690000001814");
//
//        JSONObject cc1 = new JSONObject();
//        dataDetails.add(cc1);
//        JSONArray ccOption = new JSONArray();
//        cc1.put("dataKey","cs");
//        cc1.put("dataIndex",1L);
//        cc1.put("subFormId","100003690000001814");
//        cc1.put("dataOptions",ccOption);
//        JSONObject option_cc = new JSONObject();
//        option_cc.put("optionId",100001700000063120L);
//        ccOption.add(option_cc);
//
//        JSONObject bb1 = new JSONObject();
//        dataDetails.add(bb1);
//        bb1.put("dataKey","jey");
//        bb1.put("dataIndex",1L);
//        bb1.put("content","55.42");
//        bb1.put("subFormId","100003690000001814");




        //
        formDataDutyList.forEach(formDataDuty -> {
            if (formDataDuty.getSubFormId() != null) {
                //明细表
                if (formDataDuty.getDataOptions() == null) {
                    //普通字段
                    JSONObject inputDataKey = new JSONObject();
                    inputDataKey.put("dataKey", formDataDuty.getDataKey());
                    inputDataKey.put("dataIndex", formDataDuty.getDataIndex());
                    inputDataKey.put("content", formDataDuty.getContent());
                    inputDataKey.put("subFormId", formDataDuty.getSubFormId());
                    dataDetails.add(inputDataKey);
                }else {
                    JSONObject details = new JSONObject();
                    dataDetails.add(details);

                    JSONArray dataOptions = new JSONArray();
                    details.put("dataKey", formDataDuty.getDataKey());
                    details.put("dataIndex", formDataDuty.getDataIndex());
                    details.put("subFormId", formDataDuty.getSubFormId());

                    details.put("dataOptions", dataOptions);
                    List<DataOptions> dataOptions1 = formDataDuty.getDataOptions();
                    dataOptions1.forEach(e -> {
                        JSONObject option = new JSONObject();
                        option.put("optionId", e.getOptionId());
                        dataOptions.add(option);
                    });
                }

            }else  {
                //主表
                if (formDataDuty.getDataOptions() == null) {
                    //普通字段
                    JSONObject inputDataKey = new JSONObject();
                    inputDataKey.put("dataKey", formDataDuty.getDataKey());
                    inputDataKey.put("content", formDataDuty.getContent());
                    dataDetails.add(inputDataKey);
                }else {
                    //浏览按钮字段
                    // 浏览按钮
                    JSONObject details = new JSONObject();
                    dataDetails.add(details);

                    JSONArray dataOptions = new JSONArray();
                    details.put("dataKey", formDataDuty.getDataKey());
                    details.put("dataOptions", dataOptions);

                    List<DataOptions> dataOptions1 = formDataDuty.getDataOptions();
                    dataOptions1.forEach(e -> {
                        JSONObject option = new JSONObject();
                        option.put("optionId", e.getOptionId());
                        //fieldType 3为附件
                        if (formDataDuty.getFieldType() == 3) {
                            option.put("content", e.getContent());
                        }
                        dataOptions.add(option);
                    });

                }
            }
        });

        return formData;
    }


}
